<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace VanillaBeans\SlackHooker;

if (!function_exists('\VanillaBeans\SlackHooker\vbean_slackhooker')) {

    function vbean_slackhooker($message, $channel = null, $username = null, $icon = null, $now = false, $postto=null, $alsoto=null) {
        return \VanillaBeans\SlackHooker\vbean_slacknow($message, $channel, $username, $icon, $now, $postto, $alsoto);
//        add_action('shutdown','\VanillaBeans\SlackHooker\vbean_slacknow',10,4);
    }

}


if (!function_exists('\VanillaBeans\SlackHooker\vbean_slacknow')) {

    function vbean_slacknow($message, $channel = null, $username = null, $icon = null, $now = false, $urls=null, $extraurls=null) {
        
        if(empty($urls)){
            $urls = get_option('vbean_slack_hooker_webhookurl');
        }
        if(!empty($extraurls)){
            $urls.=','.$extraurls;
        }

        if (empty($channel)) {
            $channel = get_option('vbean_slack_hooker_defaultchannel');
        }
        $channel = str_replace('#', '', $channel);
        if($channel==''){
            $channel = 'general';
        }

        if (empty($username)) {
            $username = get_option('vbean_slack_hooker_defaultusername');
        }

        if (empty($icon)) {
            $icon = get_option('vbean_slack_hooker_defaulticon');
        }

        if (!empty($icon)) {
            $icon = str_replace(':', '', $icon);
            $icon = ':'.$icon.':';
            $obj = array(
                "channel" => "#{$channel}",
                "text" => $message,
                "username" => $username,
                "icon_emoji" => $icon
            );
        } else {
            $obj = array(
                "channel" => "#{$channel}",
                "text" => $message,
                "username" => $username
            );
        }

        $str = json_encode($obj);

        $args = array(
            'urls' => $urls,
            'method' => 'POST',
            'timeout' => 45,
            'redirection' => 5,
            'httpversion' => '1.0',
            'headers' => array(),
            'body' => array('payload' => $str));

        
        if ($now) {
            // send it immediately rather than at end of php


            $response = \VanillaBeans\SlackHooker\vbean_slackdelayedremotepost($args);
            return $response;
        } else {
            //add_action('shutdown',wp_remote_post(get_option('vbean_slack_hooker_webhookurl'), $args),10,2);
//            var_dump($args);
//            die;
            if (!function_exists('curl_init')) {
                $urllist = explode(',',$urls);
                $response ='';
                foreach ($urllist as $url){
                    $response.= \VanillaBeans\SlackHooker\vbean_slackremotepost($args,$url);
                }
                return 'Deferred post not available.<br />' . $response;
            } else {
                
                
                $cron_url = site_url( 'wp-cron.php?custom_cron=vbean_slacktemp&urls='.urlencode($urls).'&payload='.urlencode($str));
                wp_remote_post( $cron_url, array( 'timeout' => 0.01, 'blocking' => false, 'sslverify' => apply_filters( 'https_local_ssl_verify', false ) ) );
                
                return 'delayed';
            }

// set as cron job
//            add_action('vanillabean_hookslack',function() use($args){
//                \VanillaBeans\SlackHooker\vbean_slackremotepost($args);
//            },10,1);
        }
    }

}

 add_action('init', '\VanillaBeans\SlackHooker\run_customcron');
    function run_customcron() 
    {
        if (isset($_GET['custom_cron']))
        {
             $obj = array(
                "channel" => "#general",
                "text" => 'foo',
                "username" => 'fubar'
            );
            $str = json_encode($obj);
            
           $payload = urldecode_deep($_GET['payload']);
           $payload = stripslashes($payload);
           $urls = urldecode($_GET['urls']);
           $urls = stripslashes($urls);
           $body = $str.PHP_EOL.'       '.$payload;
           
//           wp_mail('you@yourdomain.com', 'degugging payloads json', $body);

           
        $args = array(
            'urls' => $urls,
            'method' => 'POST',
            'timeout' => 45,
            'redirection' => 5,
            'httpversion' => '1.0',
            'headers' => array(),
            'body' => array('payload' => $payload));
            
            // \VanillaBeans\SlackHooker\vbean_slacktemp();
//            var_dump($args);
//            die;
            \VanillaBeans\SlackHooker\vbean_slackdelayedremotepost($args);
        }
    }


if (!function_exists('\VanillaBeans\SlackHooker\vbean_slackdelayedremotepost')) {

    function vbean_slackdelayedremotepost($args) {
        $urls = explode(',', $args['urls']);
        foreach ($urls as $url){
            \VanillaBeans\SlackHooker\vbean_slacksend( $args, $url);
        }
        // Timeout in seconds

    }

}

//if (!function_exists('\VanillaBeans\SlackHooker\vbean_slacktemp')) {
//
//    function vbean_slacktemp() {
//        
//        $obj = array(
//            "channel" => "#general",
//            "text" => 'static slack test message'.time(),
//            "username" => 'foobar'
//        );
//
//        $ch = curl_init(get_option('vbean_slack_hooker_webhookurl'));
//        // Timeout in seconds
//        curl_setopt($ch, CURLOPT_TIMEOUT, 45);
//        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
//        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
//        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
//        curl_setopt($ch, CURLOPT_POSTFIELDS, 'payload=' . json_encode($obj));
//        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
//
//// Download the given URL, and return output
//        $output = curl_exec($ch);
//        // Close the cURL resource, and free system resources
//        curl_close($ch);
//
//        return $output;
//    }
//
//}

if (!function_exists('\VanillaBeans\SlackHooker\vbean_slackremotepost')) {

    function vbean_slackremotepost($args,$url) {
        if(CanSend($url)){
            $response = wp_remote_post($url, $args);
        }else{
            $response=false;
        }
        return $response;
    }

}

// sends message to a singular url
if(!function_exists('\VanillaBeans\SlackHooker\vbean_slacksend')){
    function vbean_slacksend($args,$url){
        if(         CanSend($url)){
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_TIMEOUT, 45);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, 'payload=' . $args['body']['payload']);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

// Download the given URL, and return output
        $output = curl_exec($ch);
        // Close the cURL resource, and free system resources
        curl_close($ch);

        return $output;
        }
    }
}

if(!function_exists('\VanillaBeans\SlackHooker\CanSend')){
    function CanSend($url){
        $can=true;
        $found=false;
        $count=0;
        $maxper = (int)  get_option('vbean_slack_hooker_maximumper');
        $maxperseconds = (int)  get_option('vbean_slack_hooker_maximumperseconds');
        $thishit = time();
        $limit = get_option('vbean_slack_hooker_limitfrequency');
        if($limit!='1'){
            return true;
        }
        $lastoption =  get_option('vbean_slack_hooker_lastmessage');
        if($lastoption==''){
            $lasts = array(array('url'=>$url,'lasthit'=>$thishit,'total'=>1));
            $save = serialize($lasts);
            update_option('vbean_slack_hooker_lastmessage',$save);
            return true;
        }else{
            $lasts = maybe_unserialize($lastoption);
            for ($i=0;$i<count($lasts);$i++){
                if($lasts[$i]['url']==$url){
                    $found=true;
                    $lasttime = (int)$lasts[$i]['lasthit'];
                    $total = (int)$lasts[$i]['total'];
                    $lasts[$i]['total']=$total+1;
                    $seconds = $thishit-(int)$lasts[$i]['lasthit'];
                    if($seconds>=$maxperseconds){
                        $lasts[$i]['total']=1;
                        $lasts[$i]['lasthit'] =  $thishit;
                        $save = serialize($lasts);
                        update_option('vbean_slack_hooker_lastmessage',$save);
                        return true;
                    }else{
                        $save = serialize($lasts);
                        update_option('vbean_slack_hooker_lastmessage',$save);
                        if($maxper>$total){
                            return true;
                        }else{
                            return false;
                        }
                    }
                }
                    
            }
            if(!$found){
                $thislast = array('url'=>$url,'lasthit'=>$thishit,'total'=>1);
                array_push($lasts, $thislast);
            }
            
            $save = serialize($lasts);
            update_option('vbean_slack_hooker_lastmessage',$save);
            return true;
            
        }
        
    }
}




if (!function_exists('\VanillaBeans\SlackHooker\vbean_slacknotify')) {

    function vbean_slacknotify($atts) {
        $a = shortcode_atts(array(
            'postto' => $postto,
            'alsoto'=>$alsoto,
            'text' => $text,
            'channel' => $channel,
            'username' => $username,
            'icon' => $icon,
            'sendnow' => $sendnow
                ), $atts);




        $slack = \VanillaBeans\SlackHooker\vbean_slackhooker($a['text'], $a['channel'], $a['username'], $a['icon'], $a['sendnow'], $a['postto'],$a['alsoto']);

        if (is_wp_error($slack)) {
            // bad url or something
        } elseif (!empty($slack['response'])) {

            if ($slack['body'] == 'ok') {
                // all good
            } else {
                // error defined by slack
            }
        } else {
            // failed - no response
        }
    }

}
add_shortcode('slackglobal', '\VanillaBeans\SlackHooker\vbean_slacknotify');



// when a comment is inserted
add_action('wp_insert_comment', '\VanillaBeans\SlackHooker\vbean_comment_inserted', 99, 2);


if (!function_exists('\VanillaBeans\SlackHooker\vbean_comment_inserted')) {

    function vbean_comment_inserted($comment_id, $comment_object) {
        if ($comment_object && get_option('vbean_slack_hooker_commentalert')) {
            $postid = $comment_object->comment_post_ID;
            $msg = 'Comment added to your site. for ' . get_permalink($postid) . ' ' . PHP_EOL . 'by ' . $comment_object->comment_author;
            if (!empty($comment_objext->comment_author_email)) {
                $msg.='<' . $comment_objext->comment_author_email . '> ';
            }
            if (get_option('vbean_slack_hooker_commentalertcontent')) {
                $msg.=PHP_EOL . '```' . $comment_object->comment_content . '```';
            }
            $ar = array('text' => $msg, 'icon' => ':open_mouth:');
            \VanillaBeans\SlackHooker\vbean_slacknotify($ar);
        }
    }

}
